// Copyright (C) 2022 Check Point Software Technologies Ltd. All rights reserved.

// Licensed under the Apache License, Version 2.0 (the "License");
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef __ORCHESTRATION_STATUS_H__
#define __ORCHESTRATION_STATUS_H__

#include "i_orchestration_status.h"

#include <cereal/archives/json.hpp>

#include "singleton.h"
#include "component.h"
#include "i_orchestration_tools.h"
#include "i_time_get.h"
#include "i_mainloop.h"
#include "i_agent_details.h"
#include "i_details_resolver.h"
#include "customized_cereal_map.h"

class OrchestrationStatus
        :
    public Component,
    Singleton::Provide<I_OrchestrationStatus>,
    Singleton::Consume<I_TimeGet>,
    Singleton::Consume<I_AgentDetails>,
    Singleton::Consume<I_DetailsResolver>,
    Singleton::Consume<I_OrchestrationTools>,
    Singleton::Consume<I_MainLoop>
{
public:
    OrchestrationStatus();
    ~OrchestrationStatus();

    void init() override;
    
private:
    class Impl;
    std::unique_ptr<Impl> pimpl;
};

#endif // __ORCHESTRATION_STATUS_H__
